<template>
  <v-col>
    <v-col class="mb-2">
      <v-row align="end">
        <label v-if="detalleCliente">
          Mascotas
        </label>
        <v-spacer v-if="$vuetify.breakpoint.smAndUp" />
        <v-text-field
          v-model="search"
          append-icon="fal fa-search"
          label="Buscar"
          single-line
          color="accent"
          hide-details
          :style="$vuetify.breakpoint.smAndDown ? 'display: block' : 'max-width: 40vh'"
        />
      </v-row>
    </v-col>
    <v-data-table
      ref="tabla"
      v-model="selected"
      :items-per-page="10"
      :headers="seleccionable ? headersSeleccionable : headers"
      :items="filterMascotas"
      :search="search"
      class="elevation-1"
      item-key="idmascotas"
      :show-select="seleccionable"
      single-select
      @item-selected="enviarSeleccionado()"
    >
      <template #[`item.action`]="{ item }">
        <v-btn
          color="accent"
          small
          outlined

          @click="abrirDetalle(item)"
        >
          Detalle
        </v-btn>
      </template>
      <template #[`item.icons`]="{ item }">
        <v-icon
          small
          class="mr-2 fal fa-edit"
          @click="modificarMascota(item)"
        />
        <v-icon
          small
          class="fal fa-trash-alt"
          @click="eliminarMascota(item.idmascotas)"
        />
      </template>
    </v-data-table>

    <v-dialog v-model="dialogObs" width="700" :fullscreen="$vuetify.breakpoint.smAndDown" >
      <v-card v-if="dialogObs">
        <v-card-title>Observaciones</v-card-title>
        <v-card-text>
          <v-textarea
            v-model="Obs"
            outlined
            disabled
            color="accent"
            label="Observaciones"
          />
        </v-card-text>
        <v-card-actions :class="$vuetify.theme.dark ? 'grey darken-4' : 'grey lighten-4'">
          <v-btn class="elevation-2 font-weight-light" @click="cerrarDetalle">
            Cerrar
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-col>
</template>

<script lang="ts">
import { Component, Prop, Ref, Vue } from 'vue-property-decorator'
import { Mascota } from '~/core/models/mascota'
import { MascotasStore } from '~/store/MascotasStore'
import AppToast from '~/core/utils/AppToast'
import { Cliente } from '~/core/models/cliente'

@Component
export default class listaMascotas extends Vue {
  @Ref() tabla;
  @Prop({ default: null }) mascotaSeleccionado!:Mascota;
  @Prop({ default: null }) clienteActual!:Cliente;
  @Prop({ default: false }) seleccionable!:boolean;
  @Prop({ default: false }) detalleCliente!:boolean;

  search = '';
  selected:Mascota[] = [];
  dialogObs:Boolean = false;
  Obs:String = '';

  headersSeleccionable = [
    this.seleccionable ? { text: 'Seleccione', align: 'left', value: 'data-table-select' } : { sortable: false },
    { text: 'Nombre', align: 'left', value: 'nombre' },
    { text: 'Raza', align: 'left', value: 'raza' },
    { text: 'Sexo', align: 'left', value: 'sexo' },
    { value: 'action', align: 'right', sortable: false },
    { value: 'icons', align: 'right', sortable: false, width: 80 }
  ];

  headers = [
    { text: 'Nombre', align: 'left', value: 'nombre' },
    { text: 'Raza', align: 'left', value: 'raza' },
    { text: 'Sexo', align: 'left', value: 'sexo' },
    { value: 'action', align: 'right', sortable: false },
    { value: 'icons', align: 'right', sortable: false, width: 80 }
  ];

  get mascotas ():Mascota[] {
    return MascotasStore.mascotas
  }

  get filterMascotas ():Mascota[] {
    return this.mascotas && this.clienteActual ? this.mascotas.filter(p => p.clientes_idclientes === this.clienteActual.idclientes) : []
  }

  mounted () {
    if (this.mascotaSeleccionado === null) {
      this.selected = []
    } else { this.selected.push(this.mascotaSeleccionado) }
  }

  modificarMascota (val) {
    this.$emit('onEdit', val)
  }

  eliminarMascota (id:number) {
    this.$confirm('¿Está seguro?').then(async (res) => {
      if (res) {
        await MascotasStore.eliminarMascota(id)
        AppToast.info('Mascota eliminada')
      }
    }).catch()
  }

  enviarSeleccionado () {
    setTimeout(() => {
      this.$emit('selectedMascota', this.selected[0])
    }, 300)
  }

  abrirDetalle (mascota:Mascota) {
    this.Obs = mascota.observaciones
    this.dialogObs = true
  }

  cerrarDetalle () {
    this.Obs = null
    this.dialogObs = false
  }
}
</script>

<style lang="scss">

</style>
